--[[
The MIT License (MIT)

Copyright (c) 2014 James Wilkinson, Overkill Software

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
]]--


local Options = NPCWeap.loaded_options
function NPCWeap:Save()
	local fileName = NPCWeap.save_path .. "NPCWeapoptions.ini"
	local file = io.open(fileName, "w+")
	local contents = ""
	for p, d in pairs(Options) do	
		if type(d) == "table" then
			contents = string.format( "%s[%s]\n", contents, tostring(p) )
			for t, h in pairs(d) do
				contents = string.format( "%s%s=%s\n", contents, tostring(t), tostring(h) )
			end
		end
	end
	file:write(contents)
	file:close()
end

local write_Options = NPCWeap.write_options
function NPCWeap:write_the_options()
	local fileName = NPCWeap.save_path .. "NPCWeapoptions.ini"
	local file = io.open(fileName, "w")
	local contents = ""
	for p, d in pairs(write_Options) do	
		if type(d) == "table" then
			contents = string.format( "%s[%s]\n", contents, tostring(p) )
			for t, h in pairs(d) do
				contents = string.format( "%s%s=%s\n", contents, tostring(t), tostring(h) )
			end
		end
	end
	file:write(contents)
	file:close()
	NPCWeap:Load_options()
end

function NPCWeap:Load_options()
	local file = io.open(NPCWeap.save_path .. "NPCWeapoptions.ini", 'r')
	if file == nil then
		NPCWeap:write_the_options()
		return
	end
	local key
	for line in file:lines() do
		local loadKey = line:match('^%[([^%[%]]+)%]$')
		if loadKey then
			key = tonumber(loadKey) and tonumber(loadKey) or loadKey
			Options[key] = Options[key] or {}
		end
		local param, val = line:match('^([%w|_]+)%s-=%s-(.+)$')
		if param and val ~= nil then
			if tonumber(val) then
				val = tonumber(val)
			elseif val == "true" then
				val = true
			elseif val == "false" then
				val = false
			end
			if tonumber(param) then
				param = tonumber(param)
			end
			Options[key][param] = val
		end
	end
	file:close()
end